<?php
/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */
class GFHANNANSMS_Pro_PAYAMRESAN {

    /*custom code*/

    static $ApiKey;
    static $BaseUrl = "https://api.sms-webservice.com/api/V3/";

	/*
	* Gateway title	
	*/
	public static function name($gateways) {
	
		$name = __('وب سرویس OTP', 'GF_SMS' );
		
		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class())) => $name );
		return array_unique( array_merge( $gateways , $gateway ) );
	}
	
	
	/*
	* Gateway parameters
	*/
	public static function options(){
		return array(
			/*'username'  => __('نام کاربری','GF_SMS'),
			'password'  => __('پسورد','GF_SMS'),*/
            /*custom code*/
            'api_key'  => __('کلید وب سرویس','GF_SMS')
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit(){
		return true;
	}

    /*custom code*/
    public static function SendTokenSingle($TemplateKey , $Destination, $param1 , $param2 , $param3){

        $params = array(
            'ApiKey' => self::$ApiKey,
            'TemplateKey' => $TemplateKey,
            'Destination' => $Destination,
            'p1' => $param1,
            'p2' => $param2,
            'p3' => $param3,
        );

        $url = self::$BaseUrl.'SendTokenSingle?' . http_build_query($params);
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
        ));

        $response = curl_exec($curl);
        curl_close($curl);

        $response = json_decode($response)->ErrorCode;

        return $response;
    }

    /*custom code*/

    public static function getCurrentCredit(){

        $curl = curl_init();
        $data = array(
            'ApiKey'=>self::$ApiKey
        );
        $data_json = json_encode($data);
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.sms-webservice.com/api/V3/AccountInfo',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>$data_json,
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);
        $response = json_decode($response)->Result->Credit;
        curl_close($curl);
        return $response;
    }

	/*
	* Gateway action
	*/	
	public static function process( $options, $action, $from, $to, $messages ){

		if ( $action == 'credit' && !self::credit() ) {
			return false;
		}

        //custom code
        if($action == 'send')
        {
            $messages_exp = explode(':', $messages);
            if(is_array($messages_exp))
            {
                $templatekey = $messages_exp[0];
                $param1 = $messages_exp[1];
                if(array_key_exists(2, $messages_exp))
                {
                    $param2 =  $messages_exp[2];
                }
                else
                {
                    $param2 =  '8955';
                }
              if(array_key_exists(3, $messages_exp))
              {
                  $param3 =  $messages_exp[3];
              }
              else
              {
                  $param3 =  '6584';
              }
            }
        }


        /*
		if ( ! extension_loaded('soap') )
			return __('ماژول Soap بر روی هاست شما فعال نمی باشد .','GF_SMS');*/
		

		
		/*$username = $options['username'];
		$password = $options['password'];
		
		ini_set("soap.wsdl_cache_enabled", "0");*/

        /*custom code*/
        self::$ApiKey  = $options['api_key'];
		
		$to = explode(',', $to);
		$i = sizeOf($to);
		while($i--){
			$uNumber = Trim($to[$i]);
			$ret = &$uNumber;
			if (substr($uNumber,0, 5) == '%2B98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 5) == '%2b98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 4) == '0098'){ 
				$ret = substr($uNumber, 4);
			}
			if (substr($uNumber,0, 3) == '098')	{ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 3) == '+98'){ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 2) == '98'){ 
				$ret = substr($uNumber, 2);
			}
			$to = $ret;
            /*custom code*/

            if ($action == "send") {
                    /*custom code*/
                    $send = self::SendTokenSingle($templatekey , $to, $param1 , $param2 , $param3) ;
            }

		}

        if ($action == "credit") {
            $credit = self::getCurrentCredit();
        }

		
		if ($action == "send"){
			if ( $send == 1 ) {
				return __('ApiKey نادرست است', 'GF_SMS' );
			}
			else if ( $send == 9 ){
				return __('مقادیر ورودی نادرست است. - الگو پیدا نشد.', 'GF_SMS' );
			}
			else if ( $send == 13 ){
				return __('شماره شماره دریافت کننده باید با 9 یا 989 شروع شود', 'GF_SMS' );
			}
            else if ( is_null($send) ){
                return 'OK';
            }
			else {
				return __('خطای ناشناخته .', 'GF_SMS' );
			}
		}
		
		if ($action == "credit") {
			if ( $credit == -1 ) {
				return __('نام کاربری یا کلمه عبور اشتباه است .', 'GF_SMS' );
			}
			return ( (int) $credit ) . __(' پیامک', 'GF_SMS' );
		}

		
		if ($action == "range"){
			$min = 100;
			$max = 200;
			return array("min" => $min, "max" => $max);
		}

	}
}